Scriptname FPV_AggressorScript extends Quest

Actor Property PlayerRef Auto Const
GlobalVariable Property AFV_Global_Duration Auto Const
GlobalVariable Property AFV_Global_Use_Furniture Auto Const
GlobalVariable Property AFV_Global_Furniture_Pref Auto Const
GlobalVariable Property AFV_Global_Scan_Radius Auto Const
GlobalVariable Property AFV_Global_Use_Player_Loc Auto Const
GlobalVariable Property AFV_Global_Debug Auto Const
GlobalVariable Property AFV_Global_Swap_Gender_A Auto Const
RefCollectionAlias Property GenderSwappedVictims Auto

AAF:AAF_API AAF_API	

Import FPV_Logger

Function ViolateAggressor(Actor[] actors)
	AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API
	AAF:AAF_API:SceneSettings settings = AAF_API.GetSceneSettings()
	RegisterForCustomEvent(AAF_API, "OnSceneInit")
	
	AFVTrace(AFV_Global_Debug.GetValue(), "AFV FPV_AggressorScript: start with " + actors)

	If (AFV_Global_Use_Player_Loc.getValue() == 1.0)
		settings.locationObject = actors[0]
	EndIf

	settings.duration = AFV_Global_Duration.getValue()
	settings.preventFurniture = (AFV_Global_Use_Furniture.getValue() == 0.0)
	settings.scanRadius = AFV_Global_Scan_Radius.getValue() as Int
	settings.furniturePreference = AFV_Global_Furniture_Pref.getValue() as Int
	settings.isNPCControlled = true
	settings.usePackages = true
	settings.skipWalk = true
	settings.includeTags = "Aggressive"
	
	If (AFV_Global_Swap_Gender_A.GetValue() as Int != 0 && actors[0].GetLeveledActorBase().GetSex() == 0 && actors[1].GetLeveledActorBase().GetSex() == 1)
		AFVTrace(AFV_Global_Debug.GetValue(), "AFV FPV_AggressorScript: swap gender on " + actors[0].GetLeveledActorBase().GetName())
		GenderSwappedVictims.AddRef(actors[0])
		settings.excludeTags = "Spanking,Jackoff,Pose,Tease,Foreplay,Finish,TitJob,Missionary,FromFront"
	Else
		settings.excludeTags = "Spanking,Jackoff,Pose,Tease,Foreplay,Finish,TitJob"
	EndIf

	If actors.find(PlayerRef) > -1
		settings.meta = "AAF_Violate,PlayerRapist"
		Game.IncrementStat("Assaults",1)
	else
		settings.meta = "AAF_Violate"
	endif
	
	AAF_API.StartScene(actors, settings)
EndFunction

Bool Function CheckMeta(Var akArg) Global
	String meta = akArg as String
	If (meta)
		String[] metaKeywords = LL_FourPlay.StringSplit(theString = meta, delimiter = ",")
		Return (metaKeywords.Find("AAF_Violate") > -1)
	Endif
	Return False
EndFunction

Event AAF:AAF_API.OnSceneInit(AAF:AAF_API akSender, Var[] akArgs)
	UnregisterForCustomEvent(AAF_API, "OnSceneInit")
	Int iResult =  akArgs[0] as Int
	If iResult > 0 && checkMeta(akArgs[3])
		AFVTrace(AFV_Global_Debug.GetValue(), "AFV FPV_AggressorScript: animation failed to start, result [" + iResult + "]")
		AFVNotify(True, "AAF OnSceneInit status [" + iResult + "]")
	ElseIf checkMeta(akArgs[5])
		AFVTrace(AFV_Global_Debug.GetValue(), "AFV FPV_AggressorScript: OnSceneInit event")
	EndIf
EndEvent
