Scriptname FPV_MCM_Script extends Quest

Group General
	Actor Property PlayerRef Auto Const
	FPV_OnHit Property FPV_Script Auto
	Quest Property FPV_Player Auto Const
	String Property FPVHotkeyID = "FPV_SurrenderKey" Auto Const
EndGroup

Group SettingsGlobals
	GlobalVariable property AFV_MCMHasLoaded auto
	GlobalVariable property AFV_Global_Debug auto
	GlobalVariable property AFV_Global_On auto
	GlobalVariable property AFV_Global_PlayerAffected auto
	GlobalVariable property AFV_Global_Health auto
	GlobalVariable Property AFV_Global_BadEndChance auto
	GlobalVariable Property AFV_Global_BadEndFatal auto
	GlobalVariable property AFV_Global_Cripple auto
	GlobalVariable property AFV_Global_Chance auto
	GlobalVariable property AFV_Global_Gender auto
	GlobalVariable property AFV_Global_Essential auto
	GlobalVariable property AFV_Global_Exhaustion auto
	GlobalVariable property AFV_Global_Perversion auto
	GlobalVariable property AFV_Global_Steal auto
	GlobalVariable property AFV_Global_Health_A auto
	GlobalVariable property AFV_Global_Cripple_A auto
	GlobalVariable property AFV_Global_Gender_A auto
	GlobalVariable property AFV_Global_Chance_A auto
	GlobalVariable property AFV_Global_Unique_A auto
	GlobalVariable property AFV_Global_Follower auto
	GlobalVariable property AFV_Global_Gender_F auto
	GlobalVariable property AFV_Global_Teleport_F auto
	GlobalVariable property AFV_Global_Teleport auto
	GlobalVariable property AFV_Global_Threesome auto
	GlobalVariable property AFV_Global_Threesome_Mixed Auto
	GlobalVariable property AFV_Global_Duration auto
	GlobalVariable property AFV_Global_Walk auto
	GlobalVariable property AFV_Global_DD auto
	GlobalVariable property AFV_Global_Add_Actor_Chance auto
	GlobalVariable property AFV_Global_Companion_Dist auto
	GlobalVariable property AFV_Global_Force_Add_Round auto
	GlobalVariable Property AFV_Global_Use_Furniture Auto
	GlobalVariable Property AFV_Global_Scan_Radius Auto
	GlobalVariable Property AFV_Global_Furniture_Pref Auto
	GlobalVariable Property AFV_Global_Pacification_Time Auto
	GlobalVariable Property AFV_Global_Restraints Auto
	GlobalVariable Property AFV_Global_RealHandcuffs Auto
	GlobalVariable Property AFV_Global_RHCuffsChance Auto
	GlobalVariable Property AFV_Global_RHHingedChance Auto
	GlobalVariable Property AFV_Global_RHCollarChance Auto
	GlobalVariable property AFV_Global_RaiderPetChance Auto
	GlobalVariable property AFV_IsMajorFunctionActive Auto
	GlobalVariable Property AFV_Global_Restraints_Strip Auto
	GlobalVariable Property AFV_Global_RSEAbductionChance Auto
	GlobalVariable Property AFV_Global_Outnumber Auto
	GlobalVariable Property AFV_Global_POTC Auto
	GlobalVariable Property AFV_Global_POTCChance Auto
	GlobalVariable Property AFV_Global_Allow_HumanRaces Auto
	GlobalVariable Property AFV_Global_Allow_GhoulRaces Auto
	GlobalVariable Property AFV_Global_Allow_SynthRaces Auto
	GlobalVariable Property AFV_Global_Allow_SuperMutantRaces Auto
	GlobalVariable Property AFV_Global_Allow_DogRaces Auto
	GlobalVariable Property AFV_Global_Allow_FeralRaces Auto
	GlobalVariable Property AFV_Global_Allow_DeathclawRaces Auto
	GlobalVariable Property AFV_Global_Allow_SmallBugRaces Auto
	GlobalVariable Property AFV_Global_Allow_LargeBugRaces Auto
	GlobalVariable Property AFV_Global_Allow_CreatureRaces Auto
	GlobalVariable Property AFV_Global_Allow_GiantRaces Auto
	GlobalVariable Property AFV_Global_Allow_RobotRaces Auto
	GlobalVariable Property AFV_Global_SelfEsteemRecovery Auto
	GlobalVariable Property AFV_Global_DD_Max_Devices Auto
	GlobalVariable Property AFV_Global_DDChance Auto
	GlobalVariable Property AFV_Global_Scan_AllowHostile Auto
	GlobalVariable Property AFV_Global_Scan_RequireCombat Auto
	GlobalVariable Property AFV_Global_DD_Applyto Auto
	GlobalVariable Property AFV_Global_ShowUI Auto
	GlobalVariable Property AFV_Global_Swap_Gender_A Auto Const
EndGroup

Group FixedRaceTypes
	Race[] Property HumanRaces Auto Const
	Race[] Property GhoulRaces Auto Const
	Race[] Property SynthRaces Auto Const
	Race[] Property SuperMutantRaces Auto Const
	Race[] Property DogRaces Auto Const
	Race[] Property FeralRaces Auto Const
	Race[] Property DeathclawRaces Auto Const
	Race[] Property SmallBugRaces Auto Const
	Race[] Property LargeBugRaces Auto Const
	Race[] Property CreatureRaces Auto Const
	Race[] Property GiantRaces Auto Const
	Race[] Property RobotRaces Auto Const
EndGroup

Group DynamicRaceTypes
	Race[] Property AllowedRaces Auto
	Race[] Property BasicRaces Auto
	Race[] Property CompanionRaces Auto
	Race[] Property CustomRaces Auto
EndGroup

String ThisMod = "AAF_Violate"
bool spamProtect  = false

Import FPV_Logger

Event OnInit()
	AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: MCM Activating")
	AFV_MCMHasLoaded.SetValue(0)

	If CheckForMCM(true)
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV MCM Report: update MCM on quest init")
		UpdateMCMSettings(true)
		LoadCustomRaces()
		BuildCompanionRaces()
		BuildBasicRaces()
		BuildAllowedRaces()
		RegisterForMenuOpenCloseEvent("PauseMenu")
	EndIf
	
	RegisterForRemoteEvent(PlayerRef, "OnPlayerLoadGame")
	RegisterForExternalEvent("OnMCMSettingChange|"+ThisMod, "OnMCMSettingChange")
	
	AFV_MCMHasLoaded.SetValue(1)
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	If CheckForMCM()
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV MCM Report: update MCM on loading save")
		UpdateMCMSettings()
		LoadCustomRaces()
		BuildCompanionRaces()
		BuildBasicRaces()
		BuildAllowedRaces()
		RegisterForMenuOpenCloseEvent("PauseMenu")
	EndIf
EndEvent

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
    If (asMenuName == "PauseMenu" && !abOpening)
		BuildAllowedRaces()
	EndIf
EndEvent

Function OnMCMSettingChange(string modName, string id)
	If modName == ThisMod
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV MCM Report: update MCM on settings changes")
		UpdateMCMSettings()
	EndIf
EndFunction

Function UpdateMCMSettings(bool firstLoad = false)
	AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: MCM update settings")

	LoadSetting(AFV_Global_On, "fGlobalOn:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Duration, "fDuration:Global", 0.0, 120.0)
	LoadSetting(AFV_Global_Pacification_Time, "fPacificationTime:Global", 5.0, 120.0)
	LoadSetting(AFV_Global_Walk, "fWalk:Global", 0.0, 2.0)		
	LoadSetting(AFV_Global_DD, "fDDIntegration:Global", 0.0, 2.0)
	LoadSetting(AFV_Global_Threesome, "fThreesome:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Use_Furniture, "fEnableFurniture:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Scan_Radius, "fFurnitureSearchRadius:Global", 0.0, 1000.0)
	LoadSetting(AFV_Global_Furniture_Pref, "fFurniturePreference:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_BadEndChance, "fBadEndChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_BadEndFatal, "fBadEndFatal:Global", 0.0, 2.0)
	LoadSetting(AFV_Global_Debug, "fDebugTrace:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_PlayerAffected, "fPlayerAffected:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Health, "fHealth:PlayerSurrender", 0.0, 100.0)
	LoadSetting(AFV_Global_Cripple, "fCripple:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Chance, "fChance:PlayerSurrender", 0.0, 100.0)
	LoadSetting(AFV_Global_Steal, "fSteal:PlayerSurrender", 0.0, 100.0)
	LoadSetting(AFV_Global_Gender, "fGender:PlayerSurrender", 0.0, 2.0)
	LoadSetting(AFV_Global_Essential, "fEssential:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Exhaustion, "fExhaustion:PlayerSurrender", 0.0, 30.0)
	LoadSetting(AFV_Global_Perversion, "fPerversion:PlayerSurrender", 0.0, 30.0)
	LoadSetting(AFV_Global_Teleport, "fTeleport:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_GlobaL_Force_Add_Round, "fForceAdditionalRound:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Outnumber, "fOutnumber:PlayerSurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Health_A, "fHealth_A:EnemySurrender", 0.0, 100.0)
	LoadSetting(AFV_Global_Cripple_A, "fCripple_A:EnemySurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Gender_A, "fGender_A:EnemySurrender", 0.0, 2.0)
	LoadSetting(AFV_Global_Chance_A, "fChance_A:EnemySurrender", 0.0, 100.0)
	LoadSetting(AFV_Global_Unique_A, "fUnique_A:EnemySurrender", 0.0, 1.0)
	LoadSetting(AFV_Global_Follower, "fFollower:Follower", 0.0, 1.0)
	LoadSetting(AFV_Global_Gender_F, "fGender_F:Follower", 0.0, 2.0)
	LoadSetting(AFV_Global_Companion_Dist, "fDistance_F:Follower", 1000.0, 3000.0)
	LoadSetting(AFV_Global_Teleport_F, "fTeleport_F:Follower", 0.0, 1.0)
	LoadSetting(AFV_Global_Restraints, "fApplyRestraints:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Restraints_Strip, "fStripBeforeRestraints:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_RealHandcuffs, "fRHIntegration:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_RHCuffsChance, "fRHCuffsChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_RHHingedChance, "fRHHingedCuffsChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_RHCollarChance, "fRHCollarChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_RaiderPetChance, "fRaiderPetChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_Threesome_Mixed, "fThreesomeMixed:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Add_Actor_Chance, "fAddActorChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_RSEAbductionChance, "fRSEAbductionChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_POTC, "fPOTCIntegration:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_POTCChance, "fPOTCChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_Allow_HumanRaces, "fHumanRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_GhoulRaces, "fGhoulRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_SynthRaces, "fSynthRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_SuperMutantRaces, "fSuperMutantRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_DogRaces, "fDogRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_FeralRaces, "fFeralRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_DeathclawRaces, "fDeathclawRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_SmallBugRaces, "fSmallBugRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_LargeBugRaces, "fLargeBugRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_CreatureRaces, "fCreatureRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_GiantRaces, "fGiantRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_Allow_RobotRaces, "fRobotRaces:AggressorRaces", 0.0, 1.0)
	LoadSetting(AFV_Global_SelfEsteemRecovery, "fFPASelfEsteemRecovery:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_DD_Max_Devices, "fDDMaxDevices:Global", 0.0, 10.0)
	LoadSetting(AFV_Global_DDChance , "fDDChance:Global", 0.0, 100.0)
	LoadSetting(AFV_Global_Scan_AllowHostile, "fScanAllowHostile:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Scan_RequireCombat, "fScanRequireCombat:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_DD_Applyto, "fDDApplyTo:Global", 0.0, 2.0)
	LoadSetting(AFV_Global_ShowUI, "fShowUI:Global", 0.0, 1.0)
	LoadSetting(AFV_Global_Swap_Gender_A, "fSwapGender_A:EnemySurrender", 0.0, 1.0)
EndFunction

Function LoadSetting(GlobalVariable akGlobal, string asSetting, float afMin, float afMax)
	If akGlobal
		;AFVTrace(AFV_Global_Debug.GetValue(),"AFV MCM report: load settings for " + asSetting + " akGlobal is " + akGlobal)
		float settingBuffer = MCM.GetModSettingFloat(ThisMod, asSetting)

		If settingBuffer != akGlobal.GetValue() ;1.15 - If the value changed
			If settingBuffer <= afMax && settingBuffer >= afMin ; The setting is within the range of values 
				akGlobal.SetValue(settingBuffer)
			ElseIf settingBuffer < afMin ; The setting is improperly less than the minimum
				akGlobal.SetValue(afMin)
				MCM.SetModSettingFloat(ThisMod, asSetting, afMin)
			ElseIf settingBuffer > afMax ; The setting is improperly greater than the max
				akGlobal.SetValue(afMax)
				MCM.SetModSettingFloat(ThisMod, asSetting, afMax)
			EndIf
		EndIf
	Else
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV MCM report: no akGlobal for " + asSetting)
	EndIf
EndFunction

Function AppendArray(Race[] Source, Race[] Dest) Global
	Int i = 0
	While (i < Source.Length)
		Dest.Add(Source[i])
		i += 1
	EndWhile
EndFunction

Function BuildCompanionRaces()
	CompanionRaces = New Race[0]
	AppendArray(HumanRaces, CompanionRaces)
	AppendArray(CustomRaces, CompanionRaces)
	AppendArray(GhoulRaces, CompanionRaces)
	FPV_Script.CompanionRaces = CompanionRaces
	;AFVTrace(True, "AFV Report: CompanionRaces built with " + CompanionRaces.Length + " races")
EndFunction

Function BuildBasicRaces()
	BasicRaces = New Race[0]
	AppendArray(HumanRaces, BasicRaces)
	AppendArray(CustomRaces, BasicRaces)
	AppendArray(GhoulRaces, BasicRaces)
	AppendArray(SynthRaces, BasicRaces)
	AppendArray(SuperMutantRaces, BasicRaces)
	FPV_Script.BasicRaces = BasicRaces
	;AFVTrace(True, "AFV Report: BasicRaces built with " + BasicRaces.Length + " races")
EndFunction

Function BuildAllowedRaces()
	;float ftimeStart = Utility.GetCurrentRealTime()

	AllowedRaces = New Race[0]
	
	If (AFV_Global_Allow_HumanRaces.getvalue() as Int)
		AppendArray(HumanRaces, AllowedRaces)
		AppendArray(CustomRaces, AllowedRaces)
	EndIf
	
	If (AFV_Global_Allow_GhoulRaces.getvalue() as Int)
		AppendArray(GhoulRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_SynthRaces.getvalue() as Int)
		AppendArray(SynthRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_SuperMutantRaces.getvalue() as Int)
		AppendArray(SuperMutantRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_DogRaces.getvalue() as Int)
		AppendArray(DogRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_FeralRaces.getvalue() as Int)
		AppendArray(FeralRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_DeathclawRaces.getvalue() as Int)
		AppendArray(DeathclawRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_SmallBugRaces.getvalue() as Int)
		AppendArray(SmallBugRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_LargeBugRaces.getvalue() as Int)
		AppendArray(LargeBugRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_CreatureRaces.getvalue() as Int)
		AppendArray(CreatureRaces, AllowedRaces)
	EndIf

	If (AFV_Global_Allow_GiantRaces.getvalue() as Int)
		AppendArray(GiantRaces, AllowedRaces)
	EndIf
	
	If (AFV_Global_Allow_RobotRaces.getvalue() as Int)
		AppendArray(RobotRaces, AllowedRaces)
	EndIf
	
	FPV_Script.AllowedRaces = AllowedRaces
	
	;float ftimeEnd = Utility.GetCurrentRealTime()
	;AFVTrace(True, "AFV Report: AllowedRaces built with " + AllowedRaces.Length + " races in " + (ftimeEnd - ftimeStart) + " seconds")
	
EndFunction

Function AddRace(Race newRace)
	AFVTrace(True,"AFV report: AddRace " + newRace)
	If CustomRaces.Find(newRace) < 0
		CustomRaces.Add(newRace)
	EndIf
EndFunction

Function LoadCustomRaces()
	CustomRaces = New Race[0]

	If Game.IsPluginInstalled("Servitron.esm")
		AddRace(Game.GetFormFromFile(0x00000F99, "Servitron.esm") as Race)
	EndIf
	
	If Game.IsPluginInstalled("VulpineRace.esm")
		AddRace(Game.GetFormFromFile(0x00000F99, "VulpineRace.esm") as Race)
	EndIf
	
	If Game.IsPluginInstalled("CaN.esm")
		AddRace(Game.GetFormFromFile(0x00000F99, "CaN.esm") as Race)
		AddRace(Game.GetFormFromFile(0x0000EC7B, "CaN.esm") as Race)
		AddRace(Game.GetFormFromFile(0x0002A772, "CaN.esm") as Race)
		AddRace(Game.GetFormFromFile(0x00042DF8, "CaN.esm") as Race)
		AddRace(Game.GetFormFromFile(0x00042DF9, "CaN.esm") as Race)
		AddRace(Game.GetFormFromFile(0x00042DFA, "CaN.esm") as Race)
	EndIf
	
	If Game.IsPluginInstalled("2BFollower.esp")
		AddRace(Game.GetFormFromFile(0x0000F99, "2BFollower.esp") as Race)
	EndIf
	
	If Game.IsPluginInstalled("Droids of the Commonwealth.esm")
		AddRace(Game.GetFormFromFile(0x00004C50, "Droids of the Commonwealth.esm") as Race)
	EndIf
	
	If Game.IsPluginInstalled("whispering hills.esp")
		AddRace(Game.GetFormFromFile(0x03E05D, "Whispering Hills.esp") as Race)
		AddRace(Game.GetFormFromFile(0x040676, "Whispering Hills.esp") as Race)
	EndIf
EndFunction

bool Function CheckForMCM(bool FirstLoad = false)
	If !MCM.IsInstalled()
		If FirstLoad
			Utility.Wait(1.0)
			AFVNotify(true,"AAF_Violate: Please install Mod Configuration Menu. Reset AAF_Violate's MCM to get the MCM working.")
		Else
			AFVMessageBox(true,"AAF_Violate: Please re-install Mod Configuration Menu. Reset AAF_Violate's MCM to get the MCM working.")
		EndIf
		
		Return False
	EndIf
	
	AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: MCM installed and ready for use")
	Return True
EndFunction

Event OnControlDown(string asKeybindID)
		AFVNotify(AFV_Global_Debug.GetValue(),"AFV report: Control down: " + asKeybindID)
EndEvent

Event OnControlUp(string sKey, float fTime)
	AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: Control up: " + sKey + " held for " + fTime + " s")
	bool bIsMajorFunctionActive = AFV_IsMajorFunctionActive.GetValue()
	
	If !Utility.IsInMenuMode() && !PlayerRef.IsDead() && PlayerRef.GetSitState() == 0 && !spamProtect && !bIsMajorFunctionActive
		spamProtect = true
		If sKey == FPVHotkeyID 
			AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: MCM force surender attempt")
			FPV_Script.ForceSurrender()
		EndIf
		spamProtect = false
		
	ElseIf Utility.IsInMenuMode()
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: OnControlUp has determined player was in menu, ABORTING")
	
	ElseIf PlayerRef.IsDead()
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: OnControlUp has determined player was dead, ABORTING")
	
	ElseIf PlayerRef.GetSitState() != 0
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: OnControlUp has determined player was sitting, going to sit, or getting up from sitting, ABORTING")
	
	ElseIf spamProtect
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: OnControlUp has determined player was spamming the key, ABORTING")
	
	ElseIf bIsMajorFunctionActive
		If (fTime > 5.0)
			AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: key held for 5 seconds and major function active, calling scene outcome")
			FPV_Script.ForceOutcome()
		Else
			AFVTrace(AFV_Global_Debug.GetValue(),"AFV report: OnControlUp has determined that a major function (surrender) was active, ABORTING")
		EndIf
	EndIf
EndEvent

; FPV_MainQuest listens for this event and will restart all FPV quests when it receives it
CustomEvent OnForceUpdate

function ForceUpdateStart()
	SendCustomEvent("OnForceUpdate")
endFunction

function GCP(Actor akActor)
	AFVTrace(true, "akActor " + akActor.GetLeveledActorBase().GetName() + " running " + akActor.GetCurrentPackage())
endFunction
