Scriptname FPV_MainQuestScript extends Quest
Quest Property FPV_Player Auto Const Mandatory
Quest Property FPV_Follower Auto Const Mandatory
Quest Property FPV_Aggressor Auto Const Mandatory
Quest Property FPV_Retrieve Auto Const Mandatory
Quest Property FPV_Spectator Auto Const Mandatory
Quest Property FPV_Approach Auto Const Mandatory
Quest Property FPV_RaiderPet Auto Const Mandatory
Quest Property FPV_POTC Auto Const Mandatory
Quest Property FPV_RSEAbduction Auto

Actor Property PlayerRef Auto Const

FPV_MCM_script Property FPV_MCM Auto

GlobalVariable Property AFV_SaveVersion Auto
GlobalVariable Property AFV_Global_Updating Auto

Import FPV_Logger

;
; This quest exists solely to cleanly stop and start the other quests
;

Float Function FPV_GetCurrentVersion()
	return 1.45
EndFunction

Event OnQuestInit()
	AFVTrace(true,"AFV Report: Main Quest OnQuestInit")
	RegisterForRemoteEvent(PlayerRef, "OnPlayerLoadGame")
	RegisterForCustomEvent(FPV_MCM, "OnForceUpdate")
	CheckVersion()
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	AFVTrace(true,"AFV Report: Main Quest OnPlayerLoadGame")
	CheckVersion()
EndEvent

Function CheckVersion()
	Float CurrentVersion = FPV_GetCurrentVersion()
	Float SaveVersion = AFV_SaveVersion.GetValue()
	
	AFVTrace(true,"AFV Report: Current version " + CurrentVersion + " save version " + SaveVersion)
	
	If (CurrentVersion != SaveVersion)
		Utility.Wait(5)
		
		If (!SaveVersion)
			AFV_Global_Updating.setValue(1)
		Else
			AFV_Global_Updating.setValue(2)
		EndIf
	
		FPV_Aggressor.Stop()
		FPV_Aggressor.Start()
		FPV_Approach.Stop()
		FPV_Approach.Start()
		FPV_Player.Stop()
		FPV_Player.Start()
		FPV_RaiderPet.Stop()
		FPV_RaiderPet.Start()
		FPV_RSEAbduction.Stop()
		FPV_RSEAbduction.Start()
		FPV_POTC.Stop()
		FPV_POTC.Start()
	
		AFV_SaveVersion.SetValue(CurrentVersion)
	EndIf
EndFunction

Event FPV_MCM_Script.OnForceUpdate(FPV_MCM_Script akSender, Var[] akArgs)
	AFVNotify(true,"AAF Violate: Force update")
	AFVTrace(true,"AFV Report: Force Update Received")
	AFV_SaveVersion.SetValue(0.0)
	CheckVersion()
EndEvent
