Scriptname FPV_POTC_Script extends Quest

Actor Property PlayerRef Auto Const
GlobalVariable Property AFV_Global_Debug Auto Const

Bool PlugsLoaded = False
Bool DDLoaded = False
Int[] PlugList
Keyword DD_kw_InventoryItem
ScriptObject DDLibs

Import FPV_Logger

Function LoadPOTC()
	PlugsLoaded = (Game.isPluginInstalled("dcc-bp-lol.esp"))
	
	If (PlugsLoaded)
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Plugs of the Commonwealth loaded")
	Else
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Plugs of the Commonwealth not found")
	EndIf
EndFunction

Function LoadDD()
	DDLoaded = Game.IsPluginInstalled("Devious Devices.esm")
	
	If (DDLoaded)
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Devious Devices loaded")
		Quest DDQuest = Game.GetFormFromFile(0x09004C50, "Devious Devices.esm") as Quest
		DDlibs = DDQuest.CastAs("DD:DD_Library")
		DD_kw_InventoryItem = Game.GetFormFromFile(0x004C5B, "Devious Devices.esm") as Keyword
	Else
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Devious Devices not found")
	EndIf
EndFunction
		
Function InitPlugList()
	PlugList = new Int[24]
	
	PlugList[0] = 0x00801
	PlugList[1] = 0x00804
	PlugList[2] = 0x00807
	PlugList[3] = 0x0080A
	PlugList[4] = 0x0080D
	PlugList[5] = 0x00810
	PlugList[6] = 0x00813
	PlugList[7] = 0x00816
	PlugList[8] = 0x00819
	PlugList[9] = 0x0081C
	PlugList[10] = 0x0081F
	PlugList[11] = 0x00822
	PlugList[12] = 0x00825
	PlugList[13] = 0x00828
	PlugList[14] = 0x0082B
	PlugList[15] = 0x0082E
	PlugList[16] = 0x00831
	PlugList[17] = 0x00834
	PlugList[18] = 0x00837
	PlugList[19] = 0x0083A
	PlugList[20] = 0x0083D
	PlugList[21] = 0x00840
	PlugList[22] = 0x00843
	PlugList[23] = 0x00846
EndFunction

Function ApplyPlug(actor akActor)
	If (PlugsLoaded)
		int dieRoll = Utility.RandomInt(0,23)
	
		Armor thePlug = Game.GetFormFromFile(PlugList[dieRoll], "dcc-bp-lol.esp") as Armor
		
		If (DDLoaded == True) && (thePlug.HasKeyword(DD_kw_InventoryItem))
			AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: plug is a Devious Device")
			Var[] DDArgs = new Var[6]
			DDArgs[0] = akActor
			DDArgs[1] = thePlug
			DDArgs[2] = None
			DDArgs[3] = True
			DDArgs[4] = None
			DDArgs[5] = "none"
			DDLibs.CallFunction("EquipDevice", DDArgs)
		Else
			AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: plug is standard equipment")
			akActor.EquipItem(thePlug, false, true)
		EndIf
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Equipped " + thePlug.GetName() + " on " + akActor.GetLeveledActorBase().GetName())
	Else
		AFVTrace(AFV_Global_Debug.GetValue(),"AFV FPV_POTC: Plugs of the Commonwealth not loaded, aborting")
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
    InitPlugList()
	LoadPOTC()
	LoadDD()
EndEvent

Event OnQuestInit()
    InitPlugList()
	LoadPOTC()
	LoadDD()
	RegisterForRemoteEvent(PlayerRef, "OnPlayerLoadGame")
EndEvent

