Scriptname FPV_Script_Robber extends ReferenceAlias

Actor property PlayerRef auto const
Quest property FPV_Retrieve auto
Import FPV_Logger

Bool Finished = true

Function ActivateRobber()
	Finished = False
	AddInventoryEventFilter(None)
	StartTimer(5,0)
	AFVTrace(true,"Robber activated")
EndFunction

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If Finished == False 
		If akDestContainer == PlayerRef
			Finished = True
			RemoveAllInventoryEventFilters()
			AFVTrace(true, "AFV Report: Transferred " + aiItemCount + " of " + akBaseItem + " to " + akDestContainer)
			FPV_Retrieve.setStage(10)
		EndIf
	EndIf
EndEvent

Event OnTimer(Int TimerID)
	ObjectReference MyRef = GetReference()
	If (MyRef)
		If (MyRef.isDeleted() || MyRef.isDisabled())
			AFVNotify(true,"Robber has disappeared")
			FPV_Retrieve.setStage(10)
		Else
			StartTimer(5,0)
		EndIf
	Else
		AFVTrace(true,"AFV Report: Robber alias is None")
	EndIf
EndEvent
